Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 7897)
@@ -1757,5 +1728,4 @@
       END SELECT
 
-
       ! 4. north fold treatment
       ! -----------------------
@@ -1773,4 +1743,5 @@
       !
    END SUBROUTINE mpp_lnk_sum_2d
+
 
    SUBROUTINE mppsend( ktyp, pmess, kbytes, kdest, md_req )
@@ -2015,5 +1986,5 @@
       !!                 ***  routine mppmax_a_real  ***
       !!
-      !! ** Purpose :   Maximum
+      !! ** Purpose :   Maximum of a 1D array
       !!
       !!----------------------------------------------------------------------
@@ -2039,5 +2010,5 @@
       !!                  ***  routine mppmax_real  ***
       !!
-      !! ** Purpose :   Maximum
+      !! ** Purpose :   Maximum for each element of a 1D array
       !!
       !!----------------------------------------------------------------------
@@ -2057,5 +2028,6 @@
    END SUBROUTINE mppmax_real
 
-   SUBROUTINE mppmax_real_multiple( ptab, NUM , kcom  )
+
+   SUBROUTINE mppmax_real_multiple( pt1d, kdim, kcom  )
       !!----------------------------------------------------------------------
       !!                  ***  routine mppmax_real  ***
@@ -2064,19 +2036,16 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:) ,  INTENT(inout)           ::   ptab   ! ???
-      INTEGER , INTENT(in   )           ::   NUM
-      INTEGER , INTENT(in   ), OPTIONAL ::   kcom   ! ???
+      REAL(wp), DIMENSION(kdim), INTENT(inout) ::   pt1d   ! 1D arrays
+      INTEGER                  , INTENT(in   ) ::   kdim
+      INTEGER , OPTIONAL       , INTENT(in   ) ::   kcom   ! local communicator
       !!
       INTEGER  ::   ierror, localcomm
-      REAL(wp) , POINTER , DIMENSION(:) ::   zwork
-      !!----------------------------------------------------------------------
-      !
-      CALL wrk_alloc(NUM , zwork)
+      !!----------------------------------------------------------------------
+      !
       localcomm = mpi_comm_opa
       IF( PRESENT(kcom) )   localcomm = kcom
       !
-      CALL mpi_allreduce( ptab, zwork, NUM, mpi_double_precision, mpi_max, localcomm, ierror )
-      ptab = zwork
-      CALL wrk_dealloc(NUM , zwork)
+      CALL mpi_allreduce( ptab, zwork, kdim, mpi_double_precision, mpi_max, localcomm, ierror )
+      ptab(:) = zwork(:)
       !
    END SUBROUTINE mppmax_real_multiple
@@ -2251,6 +2220,6 @@
       !!-----------------------------------------------------------------------
       !
-      zmin  = MINVAL( ptab(:,:) , mask= pmask == 1.e0 )
-      ilocs = MINLOC( ptab(:,:) , mask= pmask == 1.e0 )
+      zmin  = MINVAL( ptab(:,:) , mask= pmask == 1._wp )
+      ilocs = MINLOC( ptab(:,:) , mask= pmask == 1._wp )
       !
       ki = ilocs(1) + nimpp - 1
@@ -2279,9 +2248,9 @@
       !!
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab         ! Local 2D array
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask        ! Local mask
-      REAL(wp)                         , INTENT(  out) ::   pmin         ! Global minimum of ptab
-      INTEGER                          , INTENT(  out) ::   ki, kj, kk   ! index of minimum in global frame
-      !!
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   ptab         ! Local 2D array
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   pmask        ! Local mask
+      REAL(wp)                  , INTENT(  out) ::   pmin         ! Global minimum of ptab
+      INTEGER                   , INTENT(  out) ::   ki, kj, kk   ! index of minimum in global frame
+      !
       INTEGER  ::   ierror
       REAL(wp) ::   zmin     ! local minimum
@@ -2290,6 +2259,6 @@
       !!-----------------------------------------------------------------------
       !
-      zmin  = MINVAL( ptab(:,:,:) , mask= pmask == 1.e0 )
-      ilocs = MINLOC( ptab(:,:,:) , mask= pmask == 1.e0 )
+      zmin  = MINVAL( ptab(:,:,:) , mask= pmask == 1._wp )
+      ilocs = MINLOC( ptab(:,:,:) , mask= pmask == 1._wp )
       !
       ki = ilocs(1) + nimpp - 1
@@ -2297,6 +2266,6 @@
       kk = ilocs(3)
       !
-      zain(1,:)=zmin
-      zain(2,:)=ki+10000.*kj+100000000.*kk
+      zain(1,:) = zmin
+      zain(2,:) = ki + 10000.*kj + 100000000.*kk
       !
       CALL MPI_ALLREDUCE( zain,zaout, 1, MPI_2DOUBLE_PRECISION,MPI_MINLOC,MPI_COMM_OPA,ierror)
@@ -2331,6 +2300,6 @@
       !!-----------------------------------------------------------------------
       !
-      zmax  = MAXVAL( ptab(:,:) , mask= pmask == 1.e0 )
-      ilocs = MAXLOC( ptab(:,:) , mask= pmask == 1.e0 )
+      zmax  = MAXVAL( ptab(:,:) , mask= pmask == 1._wp )
+      ilocs = MAXLOC( ptab(:,:) , mask= pmask == 1._wp )
       !
       ki = ilocs(1) + nimpp - 1
@@ -2359,17 +2328,17 @@
       !!
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab         ! Local 2D array
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask        ! Local mask
-      REAL(wp)                         , INTENT(  out) ::   pmax         ! Global maximum of ptab
-      INTEGER                          , INTENT(  out) ::   ki, kj, kk   ! index of maximum in global frame
-      !!
-      REAL(wp) :: zmax   ! local maximum
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   ) ::   ptab         ! Local 2D array
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   ) ::   pmask        ! Local mask
+      REAL(wp)                   , INTENT(  out) ::   pmax         ! Global maximum of ptab
+      INTEGER                    , INTENT(  out) ::   ki, kj, kk   ! index of maximum in global frame
+      !
+      INTEGER  ::   ierror   ! local integer
+      REAL(wp) ::   zmax     ! local maximum
       REAL(wp), DIMENSION(2,1) ::   zain, zaout
       INTEGER , DIMENSION(3)   ::   ilocs
-      INTEGER :: ierror
       !!-----------------------------------------------------------------------
       !
-      zmax  = MAXVAL( ptab(:,:,:) , mask= pmask == 1.e0 )
-      ilocs = MAXLOC( ptab(:,:,:) , mask= pmask == 1.e0 )
+      zmax  = MAXVAL( ptab(:,:,:) , mask= pmask == 1._wp )
+      ilocs = MAXLOC( ptab(:,:,:) , mask= pmask == 1._wp )
       !
       ki = ilocs(1) + nimpp - 1
@@ -2377,6 +2346,6 @@
       kk = ilocs(3)
       !
-      zain(1,:)=zmax
-      zain(2,:)=ki+10000.*kj+100000000.*kk
+      zain(1,:) = zmax
+      zain(2,:) = ki + 10000.*kj + 100000000.*kk
       !
       CALL MPI_ALLREDUCE( zain,zaout, 1, MPI_2DOUBLE_PRECISION,MPI_MAXLOC,MPI_COMM_OPA,ierror)
@@ -2422,5 +2391,4 @@
 
    SUBROUTINE mpp_comm_free( kcom )
-      !!----------------------------------------------------------------------
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kcom
@@ -2692,12 +2660,11 @@
       !!              and apply lbc north-fold on this sub array. Then we
       !!              scatter the north fold array back to the processors.
-      !!
-      !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pt3d      ! 3D array on which the b.c. is applied
-      CHARACTER(len=1)                , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
-      !                                                              !   = T ,  U , V , F or W  gridpoints
-      REAL(wp)                        , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
-      !!                                                             ! =  1. , the sign is kept
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pt3d      ! 3D array on which the b.c. is applied
+      CHARACTER(len=1)          , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
+      REAL(wp)                  , INTENT(in   ) ::   psgn      ! sign used across the north fold
+      !
       INTEGER ::   ji, jj, jr, jk
+      INTEGER ::   ipk                  ! 3rd dimension of the input array
       INTEGER ::   ierr, itaille, ildi, ilei, iilb
       INTEGER ::   ijpj, ijpjm1, ij, iproc
@@ -2715,12 +2682,14 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE( ztab(jpiglo,4,jpk) , znorthloc(jpi,4,jpk), zfoldwk(jpi,4,jpk), znorthgloio(jpi,4,jpk,jpni) )
-      ALLOCATE( ztabl(jpi,4,jpk), ztabr(jpi*jpmaxngh, 4, jpk) ) 
+      ipk = SIZE( pt3d, 3 )
+      !
+      ALLOCATE( ztab (jpiglo,4,ipk), znorthloc(jpi,4,ipk), zfoldwk(jpi,4,ipk), znorthgloio(jpi,4,ipk,jpni) )
+      ALLOCATE( ztabl(jpi   ,4,ipk), ztabr(jpi*jpmaxngh,4,ipk)   ) 
 
       ijpj   = 4
       ijpjm1 = 3
       !
-      znorthloc(:,:,:) = 0
-      DO jk = 1, jpk
+      znorthloc(:,:,:) = 0._wp
+      DO jk = 1, ipk
          DO jj = nlcj - ijpj +1, nlcj          ! put in xnorthloc the last 4 jlines of pt3d
             ij = jj - nlcj + ijpj
@@ -2730,12 +2699,12 @@
       !
       !                                     ! Build in procs of ncomm_north the znorthgloio
-      itaille = jpi * jpk * ijpj
+      itaille = jpi * ipk * ijpj
 
       IF ( l_north_nogather ) THEN
          !
-        ztabr(:,:,:) = 0
-        ztabl(:,:,:) = 0
-
-        DO jk = 1, jpk
+        ztabr(:,:,:) = 0._wp
+        ztabl(:,:,:) = 0._wp
+
+        DO jk = 1, ipk
            DO jj = nlcj-ijpj+1, nlcj          ! First put local values into the global array
               ij = jj - nlcj + ijpj
@@ -2747,5 +2716,5 @@
 
          DO jr = 1,nsndto
-            IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
+            IF ((nfipproc(isendto(jr),jpnj) /= (narea-1)) .and. (nfipproc(isendto(jr),jpnj) /= -1)) THEN
               CALL mppsend( 5, znorthloc, itaille, nfipproc(isendto(jr),jpnj), ml_req_nf(jr) )
             ENDIF
@@ -2753,12 +2722,12 @@
          DO jr = 1,nsndto
             iproc = nfipproc(isendto(jr),jpnj)
-            IF(iproc .ne. -1) THEN
+            IF(iproc /= -1) THEN
                ilei = nleit (iproc+1)
                ildi = nldit (iproc+1)
                iilb = nfiimpp(isendto(jr),jpnj) - nfiimpp(isendto(1),jpnj)
             ENDIF
-            IF((iproc .ne. (narea-1)) .and. (iproc .ne. -1)) THEN
+            IF((iproc /= (narea-1)) .and. (iproc /= -1)) THEN
               CALL mpprecv(5, zfoldwk, itaille, iproc)
-              DO jk = 1, jpk
+              DO jk = 1, ipk
                  DO jj = 1, ijpj
                     DO ji = ildi, ilei
@@ -2767,6 +2736,6 @@
                  END DO
               END DO
-           ELSE IF (iproc .eq. (narea-1)) THEN
-              DO jk = 1, jpk
+           ELSE IF( iproc == narea-1 ) THEN
+              DO jk = 1, ipk
                  DO jj = 1, ijpj
                     DO ji = ildi, ilei
@@ -2779,5 +2748,5 @@
          IF (l_isend) THEN
             DO jr = 1,nsndto
-               IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
+               IF ((nfipproc(isendto(jr),jpnj) /= (narea-1)) .and. (nfipproc(isendto(jr),jpnj) /= -1)) THEN
                   CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
                ENDIF    
@@ -2785,5 +2754,5 @@
          ENDIF
          CALL mpp_lbc_nfd( ztabl, ztabr, cd_type, psgn )   ! North fold boundary condition
-         DO jk = 1, jpk
+         DO jk = 1, ipk
             DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
                ij = jj - nlcj + ijpj
@@ -2794,10 +2763,9 @@
          END DO
          !
-
       ELSE
          CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
             &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
-         ztab(:,:,:) = 0.e0
+         ztab(:,:,:) = 0._wp
          DO jr = 1, ndim_rank_north         ! recover the global north array
             iproc = nrank_north(jr) + 1
@@ -2805,5 +2773,5 @@
             ilei  = nleit (iproc)
             iilb  = nimppt(iproc)
-            DO jk = 1, jpk
+            DO jk = 1, ipk
                DO jj = 1, ijpj
                   DO ji = ildi, ilei
@@ -2815,5 +2783,5 @@
          CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
          !
-         DO jk = 1, jpk
+         DO jk = 1, ipk
             DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
                ij = jj - nlcj + ijpj
@@ -2902,5 +2870,5 @@
 
          DO jr = 1,nsndto
-            IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
+            IF ((nfipproc(isendto(jr),jpnj) /= (narea-1)) .and. (nfipproc(isendto(jr),jpnj) /= -1)) THEN
                CALL mppsend(5, znorthloc, itaille, nfipproc(isendto(jr),jpnj), ml_req_nf(jr))
             ENDIF
@@ -2908,10 +2876,10 @@
          DO jr = 1,nsndto
             iproc = nfipproc(isendto(jr),jpnj)
-            IF(iproc .ne. -1) THEN
+            IF(iproc /= -1) THEN
                ilei = nleit (iproc+1)
                ildi = nldit (iproc+1)
                iilb = nfiimpp(isendto(jr),jpnj) - nfiimpp(isendto(1),jpnj)
             ENDIF
-            IF((iproc .ne. (narea-1)) .and. (iproc .ne. -1)) THEN
+            IF( iproc /= narea-1 .AND. iproc /= -1 ) THEN
               CALL mpprecv(5, zfoldwk, itaille, iproc)
               DO jj = 1, ijpj
@@ -2920,5 +2888,5 @@
                  END DO
               END DO
-            ELSE IF (iproc .eq. (narea-1)) THEN
+            ELSE IF( iproc == narea-1 ) THEN
               DO jj = 1, ijpj
                  DO ji = ildi, ilei
@@ -2930,5 +2898,5 @@
          IF (l_isend) THEN
             DO jr = 1,nsndto
-               IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
+               IF ((nfipproc(isendto(jr),jpnj) /= (narea-1)) .and. (nfipproc(isendto(jr),jpnj) /= -1)) THEN
                   CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
                ENDIF
@@ -2948,5 +2916,5 @@
             &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
-         ztab(:,:) = 0.e0
+         ztab(:,:) = 0._wp
          DO jr = 1, ndim_rank_north            ! recover the global north array
             iproc = nrank_north(jr) + 1
@@ -2975,5 +2943,6 @@
    END SUBROUTINE mpp_lbc_north_2d
 
-   SUBROUTINE mpp_lbc_north_2d_multiple( pt2d_array, cd_type, psgn, num_fields)
+
+   SUBROUTINE mpp_lbc_north_2d_multiple( pt2d_array, cd_type, psgn, kfld )
       !!---------------------------------------------------------------------
       !!                   ***  routine mpp_lbc_north_2d  ***
@@ -2990,28 +2959,26 @@
       !!
       !!----------------------------------------------------------------------
-      INTEGER ,  INTENT (in   ) ::   num_fields  ! number of variables contained in pt2d
-      TYPE( arrayptr ), DIMENSION(:) :: pt2d_array
-      CHARACTER(len=1), DIMENSION(:), INTENT(in   ) ::   cd_type   ! nature of pt2d grid-points
-      !                                                          !   = T ,  U , V , F or W  gridpoints
-      REAL(wp), DIMENSION(:), INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
-      !!                                                             ! =  1. , the sign is kept
+      TYPE( arrayptr ), DIMENSION(:), INTENT(inout) ::   pt2d_array   ! pointer array of 2D fields
+      CHARACTER(len=1), DIMENSION(:), INTENT(in   ) ::   cd_type      ! nature of pt2d grid-points
+      REAL(wp)        , DIMENSION(:), INTENT(in   ) ::   psgn         ! sign used across the north fold 
+      INTEGER                       , INTENT(in   ) ::   kfld         ! number of variables contained in pt2d
+      !
       INTEGER ::   ji, jj, jr, jk
       INTEGER ::   ierr, itaille, ildi, ilei, iilb
-      INTEGER ::   ijpj, ijpjm1, ij, iproc
-      INTEGER, DIMENSION (jpmaxngh)      ::   ml_req_nf          !for mpi_isend when avoiding mpi_allgather
-      INTEGER                            ::   ml_err             ! for mpi_isend when avoiding mpi_allgather
-      INTEGER, DIMENSION(MPI_STATUS_SIZE)::   ml_stat            ! for mpi_isend when avoiding mpi_allgather
-      !                                                              ! Workspace for message transfers avoiding mpi_allgather
+      INTEGER ::   ijpj, ijpjm1, ij, iproc, iflag
+      INTEGER, DIMENSION (jpmaxngh)      ::   ml_req_nf   ! for mpi_isend when avoiding mpi_allgather
+      INTEGER                            ::   ml_err      ! for mpi_isend when avoiding mpi_allgather
+      INTEGER, DIMENSION(MPI_STATUS_SIZE)::   ml_stat     ! for mpi_isend when avoiding mpi_allgather
+      !                                                   ! Workspace for message transfers avoiding mpi_allgather
+      INTEGER :: istatus(mpi_status_size)
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE   :: ztab
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE   :: znorthloc, zfoldwk
       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE   :: znorthgloio
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE   :: ztabl, ztabr
-      INTEGER :: istatus(mpi_status_size)
-      INTEGER :: iflag
-      !!----------------------------------------------------------------------
-      !
-      ALLOCATE( ztab(jpiglo,4,num_fields), znorthloc(jpi,4,num_fields), zfoldwk(jpi,4,num_fields),   &
-            &   znorthgloio(jpi,4,num_fields,jpni) )   ! expanded to 3 dimensions
-      ALLOCATE( ztabl(jpi,4,num_fields), ztabr(jpi*jpmaxngh, 4,num_fields) )
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE( ztab(jpiglo,4,kfld), znorthloc  (jpi,4,kfld),        &
+         &      zfoldwk(jpi,4,kfld), znorthgloio(jpi,4,kfld,jpni),   &
+         &      ztabl  (jpi,4,kfld), ztabr(jpi*jpmaxngh, 4,kfld)   )
       !
       ijpj   = 4
@@ -3019,5 +2986,5 @@
       !
       
-      DO jk = 1, num_fields
+      DO jk = 1, kfld
          DO jj = nlcj-ijpj+1, nlcj             ! put in znorthloc the last 4 jlines of pt2d (for every variable)
             ij = jj - nlcj + ijpj
@@ -3033,8 +3000,8 @@
          ! (in nemo_northcomms) as being  involved in this process' northern boundary exchange
          !
-         ztabr(:,:,:) = 0
-         ztabl(:,:,:) = 0
-
-         DO jk = 1, num_fields
+         ztabr(:,:,:) = 0._wp
+         ztabl(:,:,:) = 0._wp
+
+         DO jk = 1, kfld
             DO jj = nlcj-ijpj+1, nlcj          ! First put local values into the global array
                ij = jj - nlcj + ijpj
@@ -3045,19 +3012,19 @@
          END DO
 
-         DO jr = 1,nsndto
-            IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
-               CALL mppsend(5, znorthloc, itaille*num_fields, nfipproc(isendto(jr),jpnj), ml_req_nf(jr)) ! Buffer expanded "num_fields" times
+         DO jr = 1, nsndto
+            IF( nfipproc(isendto(jr),jpnj) /= narea-1 .AND. nfipproc(isendto(jr),jpnj) /= -1 ) THEN
+               CALL mppsend(5, znorthloc, itaille*kfld, nfipproc(isendto(jr),jpnj), ml_req_nf(jr)) ! Buffer expanded "kfld" times
             ENDIF
          END DO
-         DO jr = 1,nsndto
+         DO jr = 1, nsndto
             iproc = nfipproc(isendto(jr),jpnj)
-            IF(iproc .ne. -1) THEN
+            IF(iproc /= -1) THEN
                ilei = nleit (iproc+1)
                ildi = nldit (iproc+1)
                iilb = nfiimpp(isendto(jr),jpnj) - nfiimpp(isendto(1),jpnj)
             ENDIF
-            IF((iproc .ne. (narea-1)) .and. (iproc .ne. -1)) THEN
-              CALL mpprecv(5, zfoldwk, itaille*num_fields, iproc) ! Buffer expanded "num_fields" times
-              DO jk = 1 , num_fields
+            IF( iproc /= narea-1 .AND. iproc /= -1 ) THEN
+              CALL mpprecv(5, zfoldwk, itaille*kfld, iproc) ! Buffer expanded "kfld" times
+              DO jk = 1 , kfld
                  DO jj = 1, ijpj
                     DO ji = ildi, ilei
@@ -3066,6 +3033,6 @@
                  END DO
               END DO
-            ELSE IF (iproc .eq. (narea-1)) THEN
-              DO jk = 1, num_fields
+            ELSEIF ( iproc == narea-1 ) THEN
+              DO jk = 1, kfld
                  DO jj = 1, ijpj
                     DO ji = ildi, ilei
@@ -3076,7 +3043,7 @@
             ENDIF
          END DO
-         IF (l_isend) THEN
-            DO jr = 1,nsndto
-               IF ((nfipproc(isendto(jr),jpnj) .ne. (narea-1)) .and. (nfipproc(isendto(jr),jpnj) .ne. -1)) THEN
+         IF( l_isend ) THEN
+            DO jr = 1, nsndto
+               IF( nfipproc(isendto(jr),jpnj) /= narea-1 .AND. nfipproc(isendto(jr),jpnj) /= -1 ) THEN
                   CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
                ENDIF
@@ -3084,9 +3051,9 @@
          ENDIF
          !
-         DO ji = 1, num_fields     ! Loop to manage 3D variables
+         DO ji = 1, kfld     ! Loop to manage 3D variables
             CALL mpp_lbc_nfd( ztabl(:,:,ji), ztabr(:,:,ji), cd_type(ji), psgn(ji) )  ! North fold boundary condition
          END DO
          !
-         DO jk = 1, num_fields
+         DO jk = 1, kfld
             DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt2d
                ij = jj - nlcj + ijpj
@@ -3100,9 +3067,9 @@
       ELSE
          !
-         CALL MPI_ALLGATHER( znorthloc  , itaille*num_fields, MPI_DOUBLE_PRECISION,        &
-            &                znorthgloio, itaille*num_fields, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
-         !
-         ztab(:,:,:) = 0.e0
-         DO jk = 1, num_fields
+         CALL MPI_ALLGATHER( znorthloc  , itaille*kfld, MPI_DOUBLE_PRECISION,        &
+            &                znorthgloio, itaille*kfld, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         !
+         ztab(:,:,:) = 0._wp
+         DO jk = 1, kfld
             DO jr = 1, ndim_rank_north            ! recover the global north array
                iproc = nrank_north(jr) + 1
@@ -3118,9 +3085,9 @@
          END DO
          
-         DO ji = 1, num_fields
+         DO ji = 1, kfld
             CALL lbc_nfd( ztab(:,:,ji), cd_type(ji), psgn(ji) )   ! North fold boundary condition
          END DO
          !
-         DO jk = 1, num_fields
+         DO jk = 1, kfld
             DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt2d
                ij = jj - nlcj + ijpj
@@ -3138,4 +3105,5 @@
    END SUBROUTINE mpp_lbc_north_2d_multiple
 
+
    SUBROUTINE mpp_lbc_north_e( pt2d, cd_type, psgn)
       !!---------------------------------------------------------------------
@@ -3155,40 +3123,36 @@
       REAL(wp), DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj), INTENT(inout) ::   pt2d     ! 2D array with extra halo
       CHARACTER(len=1)                                            , INTENT(in   ) ::   cd_type  ! nature of pt3d grid-points
-      !                                                                                         !   = T ,  U , V , F or W -points
-      REAL(wp)                                                    , INTENT(in   ) ::   psgn     ! = -1. the sign change across the
-      !!                                                                                        ! north fold, =  1. otherwise
+      REAL(wp)                                                    , INTENT(in   ) ::   psgn     ! sign used across the north fold
+      !
       INTEGER ::   ji, jj, jr
       INTEGER ::   ierr, itaille, ildi, ilei, iilb
       INTEGER ::   ijpj, ij, iproc
-      !
       REAL(wp), DIMENSION(:,:)  , ALLOCATABLE  ::  ztab_e, znorthloc_e
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE  ::  znorthgloio_e
-
       !!----------------------------------------------------------------------
       !
       ALLOCATE( ztab_e(jpiglo,4+2*jpr2dj), znorthloc_e(jpi,4+2*jpr2dj), znorthgloio_e(jpi,4+2*jpr2dj,jpni) )
-
       !
       ijpj=4
-      ztab_e(:,:) = 0.e0
-
-      ij=0
+      ztab_e(:,:) = 0._wp
+
+      ij = 0
       ! put in znorthloc_e the last 4 jlines of pt2d
       DO jj = nlcj - ijpj + 1 - jpr2dj, nlcj +jpr2dj
          ij = ij + 1
          DO ji = 1, jpi
-            znorthloc_e(ji,ij)=pt2d(ji,jj)
+            znorthloc_e(ji,ij) = pt2d(ji,jj)
          END DO
       END DO
       !
       itaille = jpi * ( ijpj + 2 * jpr2dj )
-      CALL MPI_ALLGATHER( znorthloc_e(1,1)  , itaille, MPI_DOUBLE_PRECISION,    &
+      CALL MPI_ALLGATHER( znorthloc_e(1,1)    , itaille, MPI_DOUBLE_PRECISION,    &
          &                znorthgloio_e(1,1,1), itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
       !
       DO jr = 1, ndim_rank_north            ! recover the global north array
          iproc = nrank_north(jr) + 1
-         ildi = nldit (iproc)
-         ilei = nleit (iproc)
-         iilb = nimppt(iproc)
+         ildi  = nldit (iproc)
+         ilei  = nleit (iproc)
+         iilb  = nimppt(iproc)
          DO jj = 1, ijpj+2*jpr2dj
             DO ji = ildi, ilei
@@ -3197,5 +3161,4 @@
          END DO
       END DO
-
 
       ! 2. North-Fold boundary conditions
@@ -3238,12 +3201,11 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab     ! 3D array on which the boundary condition is applied
-      CHARACTER(len=1)                , INTENT(in   ) ::   cd_type  ! define the nature of ptab array grid-points
-      !                                                             ! = T , U , V , F , W points
-      REAL(wp)                        , INTENT(in   ) ::   psgn     ! =-1 the sign change across the north fold boundary
-      !                                                             ! =  1. , the sign is kept
-      INTEGER                         , INTENT(in   ) ::   ib_bdy   ! BDY boundary set
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   ptab     ! 3D array on which the boundary condition is applied
+      CHARACTER(len=1)          , INTENT(in   ) ::   cd_type  ! nature of ptab grid point
+      REAL(wp)                  , INTENT(in   ) ::   psgn     ! sign used across the north fold boundary
+      INTEGER                   , INTENT(in   ) ::   ib_bdy   ! BDY boundary set
       !
       INTEGER  ::   ji, jj, jk, jl             ! dummy loop indices
+      INTEGER  ::   ipk                        ! 3rd dimension of the input array
       INTEGER  ::   imigr, iihom, ijhom        ! local integers
       INTEGER  ::   ml_req1, ml_req2, ml_err   ! for key_mpi_isend
@@ -3255,6 +3217,8 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE( zt3ns(jpi,jprecj,jpk,2), zt3sn(jpi,jprecj,jpk,2),   &
-         &      zt3ew(jpj,jpreci,jpk,2), zt3we(jpj,jpreci,jpk,2)  )
+      ipk = SIZE( ptab, 3 )
+      !      
+      ALLOCATE( zt3ns(jpi,jprecj,ipk,2), zt3sn(jpi,jprecj,ipk,2),   &
+         &      zt3ew(jpj,jpreci,ipk,2), zt3we(jpj,jpreci,ipk,2)  )
 
       zland = 0._wp
@@ -3263,5 +3227,5 @@
       ! ------------------------------
       !                                   ! East-West boundaries
-      !                                        !* Cyclic east-west
+      !                                        !* Cyclic
       IF( nbondi == 2) THEN
          IF( nperio == 1 .OR. nperio == 4 .OR. nperio == 6 ) THEN
@@ -3273,5 +3237,5 @@
          ENDIF
       ELSEIF(nbondi == -1) THEN
-         IF( .NOT. cd_type == 'F' )   ptab(1:jpreci,:,:) = zland    ! south except F-point
+         IF( .NOT. cd_type == 'F' )   ptab(1:jpreci,:,:) = zland       ! south except F-point
       ELSEIF(nbondi == 1) THEN
          ptab(nlci-jpreci+1:jpi,:,:) = zland    ! north
@@ -3298,5 +3262,5 @@
       !
       !                           ! Migrations
-      imigr = jpreci * jpj * jpk
+      imigr = jpreci * jpj * ipk
       !
       SELECT CASE ( nbondi_bdy(ib_bdy) )
@@ -3348,5 +3312,4 @@
          END DO
       END SELECT
-
 
       ! 3. North and south directions
@@ -3363,5 +3326,5 @@
       !
       !                           ! Migrations
-      imigr = jprecj * jpi * jpk
+      imigr = jprecj * jpi * ipk
       !
       SELECT CASE ( nbondj_bdy(ib_bdy) )
@@ -3413,5 +3376,4 @@
          END DO
       END SELECT
-
 
       ! 4. north fold treatment
@@ -3453,12 +3415,10 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptab     ! 3D array on which the boundary condition is applied
-      CHARACTER(len=1)            , INTENT(in   ) ::   cd_type  ! define the nature of ptab array grid-points
-      !                                                         ! = T , U , V , F , W points
-      REAL(wp)                    , INTENT(in   ) ::   psgn     ! =-1 the sign change across the north fold boundary
-      !                                                         ! =  1. , the sign is kept
-      INTEGER                     , INTENT(in   ) ::   ib_bdy   ! BDY boundary set
-      !
-      INTEGER  ::   ji, jj, jl             ! dummy loop indices
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(inout) ::   ptab     ! 3D array on which the boundary condition is applied
+      CHARACTER(len=1)                , INTENT(in   ) ::   cd_type  ! nature of ptab array grid-points
+      REAL(wp)                        , INTENT(in   ) ::   psgn     ! sign used across the north fold boundary
+      INTEGER                         , INTENT(in   ) ::   ib_bdy   ! BDY boundary set
+      !
+      INTEGER  ::   ji, jj, jl                 ! dummy loop indices
       INTEGER  ::   imigr, iihom, ijhom        ! local integers
       INTEGER  ::   ml_req1, ml_req2, ml_err   ! for key_mpi_isend
@@ -3478,17 +3438,17 @@
       ! ------------------------------
       !                                   ! East-West boundaries
-      !                                      !* Cyclic east-west
+      !                                         !* Cyclic
       IF( nbondi == 2 ) THEN
-         IF (nperio == 1 .OR. nperio == 4 .OR. nperio == 6) THEN
+         IF( nperio == 1 .OR. nperio == 4 .OR. nperio == 6 ) THEN
             ptab( 1 ,:) = ptab(jpim1,:)
             ptab(jpi,:) = ptab(  2  ,:)
          ELSE
-            IF(.NOT.cd_type == 'F' )  ptab(     1       :jpreci,:) = zland    ! south except F-point
-                                      ptab(nlci-jpreci+1:jpi   ,:) = zland    ! north
+            IF(.NOT.cd_type == 'F' )   ptab(     1       :jpreci,:) = zland    ! south except F-point
+                                       ptab(nlci-jpreci+1:jpi   ,:) = zland    ! north
          ENDIF
       ELSEIF(nbondi == -1) THEN
-         IF( .NOT.cd_type == 'F' )    ptab(     1       :jpreci,:) = zland    ! south except F-point
+         IF(.NOT.cd_type == 'F' )      ptab(     1       :jpreci,:) = zland    ! south except F-point
       ELSEIF(nbondi == 1) THEN
-                                      ptab(nlci-jpreci+1:jpi   ,:) = zland    ! north
+                                       ptab(nlci-jpreci+1:jpi   ,:) = zland    ! north
       ENDIF
       !                                      !* closed
